module CustomAttributes
  class IntFieldType < Numeric
    include Singleton

    def label
      "label_integer"
    end

    def cast_single_value(custom_field, value, customized=nil)
      value.to_i
    end

    def validate_single_value(custom_field, value, customizable = nil)
      errs = super
      errs << ::I18n.t('activerecord.errors.messages.not_a_number') unless value.to_s =~ /^[+-]?\d+$/
      errs
    end
  end
end
